$editMode = 1;       // 1 允许编辑  0 禁止编辑

$(function() {
    $("img:not([data-latex])").on('click', function() {
        var url = $(this).attr('src');
        window.android.onImgClick(url);
    });

    $('.single').on('click', function() {
        if(isLongPressing){
            return;
        }
        if ($editMode) {
            var className = $(this).attr('class');
            //点击包含忽略的
            if(JSON.stringify(className).includes('ignore')){
                  //变成默认状态
                  $(this).removeClass().addClass('single');
                  $(this).children('span.option').removeClass().addClass('option default');
                  $(this).children('span.option-line').removeClass().addClass('line-none');
                  var option = $(this).children('span.option').attr('val');
                  window.android.onOptionExcluded(option, false);
            }else{
                //设置选中 ，回调点击事件。
                $(this).removeClass().addClass('single singleSelected');
                $(this).children('span.option').removeClass().addClass('option selected');
                var option = $(this).children('span.option').attr('val');
                try {
                    window.android.onOptionSelected(option);
                } catch (error) {
                    
                }
            }
            
            $(this).siblings('div').each(function() {
                if ($(this).hasClass('ignore')) {
                    // 忽略状态下点击 变成默认状态
                    //忽略
                    $(this).removeClass().addClass('single ignore');
                }else if($(this).hasClass('singleSelected')){
                    if(JSON.stringify(className).includes('ignore')){
                        //不处理 忽略的样式
                    }else{
                        //设置成常规样式
                        $(this).removeClass().addClass('single');
                    }
                }else{
                    //常规样式
                    $(this).removeClass().addClass('single');
                }
            });


            $(this).siblings('div').children('span.option').each(function() {
                if ($(this).hasClass('ignore')) {
                    $(this).removeClass().addClass('option default ignore');
                }else if($(this).hasClass('selected')){
                    if(JSON.stringify(className).includes('ignore')){
                        //不处理 忽略的样式
                    }else{
                        //设置常规样式
                        $(this).removeClass().addClass('option default');
                    }
                }else{
                    //常规样式
                    $(this).removeClass().addClass('option default');
                }
            });
        }
    });

    $('.multi').on('click', function() {
        if(isLongPressing){
            return;
        }
        if ($editMode) {
            var className = $(this).attr('class');
            //点击包含忽略的
            if(JSON.stringify(className).includes('ignore')){
                //变成默认状态
                $(this).removeClass().addClass('multi');
                $(this).children('span.option').removeClass().addClass('option default');
                $(this).children('span.option-line').removeClass().addClass('line-none');
                var option = $(this).children('span.option').attr('val');
                window.android.onOptionExcluded(option, false);
            }else{
                //设置选中 ，回调点击事件。
//                $(this).removeClass().addClass('multi multiSelected');
//                $(this).children('span.option').removeClass().addClass('option selected');
                if ($(this).children('span.option').hasClass('default')) {
                    $(this).children('span.option').removeClass().addClass('option selected');
                    $(this).removeClass().addClass('multi multiSelected');
                } else {
                    $(this).children('span.option').removeClass().addClass('option default');
                    $(this).removeClass().addClass('multi');
                }
                var optionArray = new Array();
                var brothers = $(this).parent().children();
                for (var i = 0; i < brothers.length; i++) {
                    var item = brothers.eq(i);
                    if (item.children('span.option').hasClass('selected')) {
                        optionArray.push(item.children('span.option').attr('val'));
                    }
                }
                var option = optionArray.join(',');
                try {
                    window.android.onOptionSelected(option);
                } catch (error) {}
            }
        }
    });

    $('.judge').on('click', function() {
            if ($editMode) {
                $(this).children('span.option').removeClass().addClass('option selected');
                $(this).siblings('div').children('span.option').removeClass().addClass('option default');
                var option = $(this).children('span.option').attr('val');
                window.android.onOptionSelected(option);
            }
        });
});
var longPressTimer;
var isLongPressing = false;
var startX, startY;
var moveX, moveY;
const SCROLL_THRESHOLD = 10; // 滑动阈值
//长按
function startLongPress(event, element) {
    if (!$editMode) {
        return;
    }
    const currentClassList = element.classList;
    isLongPressing = false;
    const touch = event.touches[0];
    if(!startX){
        startX = touch.clientX;
        startY = touch.clientY;
    }else{
        moveX = touch.clientX;
        moveY = touch.clientY;
    }
    // 设置一个定时器，在一段时间后触发长按回调
    longPressTimer = setTimeout(function () {
        isLongPressing = true;
        // 长按回调函数
        console.log("长按触发了！");
        //处理选项里面的内容，移除optio 的其他标签，改成普通标签。
        var optionElement = element.querySelector('.option');

        if(JSON.stringify(currentClassList).includes('ignore')){
            //取消忽略
            currentClassList.remove('ignore');
           //修改 斜杠的添加
           var lineElement = element.querySelector('.option-line');
           lineElement.classList.add('line-none');

            optionElement.classList.remove('ignore');
            
            window.android.onOptionExcluded(optionElement.textContent, false);

        }else{
            //长按忽略
            var lineElement = element.querySelector('.line-none');
            if(JSON.stringify(currentClassList).includes('multi')){
                // 单选将被长按的元素的类名改为 selected
                currentClassList.remove('multiSelected');
            }else{
                // 单选将被长按的元素的类名改为 selected
                currentClassList.remove('singleSelected');
            }
            currentClassList.add('ignore');

            //修改 斜杠的添加
            lineElement.classList.add('option-line');
            lineElement.classList.remove('line-none');


            optionElement.classList.remove('selected');
            optionElement.classList.add('default');
            optionElement.classList.add('ignore');

            window.android.onOptionExcluded(optionElement.textContent, true);

        }
    }, 300);
}

function moveLongPress() {
    const deltaX = Math.abs(moveX - startX);
    const deltaY = Math.abs(moveY - startY);

    if (deltaX > SCROLL_THRESHOLD || deltaY > SCROLL_THRESHOLD) {
        isLongPressing = false;
        clearTimeout(longPressTimer);
        return; // 滑动时直接返回
    }
}

function endLongPress() {
 console.log("endLongPress ！");
    if (!$editMode) {
        return;
    }
    // 清除定时器，防止触发长按回调
    clearTimeout(longPressTimer);
    // 设置长按标志为 false
    setTimeout(() => {
        isLongPressing = false;
    }, 300);
}


/**
 * 设置是否可以修改答案
 */
function setEditable(editable) {
    $editMode = editable ? 1 : 0;
    
    window.console.warn('set editable = ' + editable);
}

function getDocumentHeightToApp(){
    setTimeout(function(){
        var img = document.createElement('img');
        img.src = 'cpa://transfer-height?height=' + ($('section:eq(0)').height() + $('section:eq(1)').height() + 40);
        document.body.append(img);
        img.style['display']='none';
      }, 500);
}

/**
 * 设置用户答案
 */
function setAnswer(answer) {
    $editMode = 0;
    var optionElements = $('.options').children();
    var length = optionElements.length < answer.length ? optionElements.length : answer.length;

    for (var i = 0; i < length; i++) {
        var cssClazz = 'default';
        if (answer[i] == -1) {
            cssClazz = 'selected';
        } else if (answer[i] == 1) {
            cssClazz = 'right';
        } else if (answer[i] == 2) {
            cssClazz = 'wrong';
        } else if (answer[i] == 3) {
            cssClazz = 'uright';
        }

        var item = optionElements.eq(i);
        item.children('span.option').removeClass().addClass('option ' + cssClazz);
    }
}

/**
 * 重置选项为可编辑状态，选项默认未选
 */
function resetOption() {
    $editMode = 1;
    var optionElements = $('.options').children();
    var length = optionElements.length;

    for (var i = 0; i < length; i++) {
        optionElements.eq(i).children('span.option').removeClass().addClass('option default');
    }
}

/**
 * 返回用户选择的答案
 */
function getAnswer() {
    var option = new Array();
    var brothers = $('.options').children('div');
    for (var i = 0; i < brothers.length; i++) {
        var item = brothers.eq(i);
        if (item.children('span:first').hasClass('selected')) {
            option.push(item.children('span:first').html());
        }
    }
    var answer = option.join(',');

    window.android.onOptionSelected(answer);
}

//重新添加click事件
function readdClick() {
  $(function() {
   $('img').off('click');
   $('img:not([data-latex])').on('click', function() {
           var url = $(this).attr('src');
           window.android.onImgClick(url);
       });
  });
}
